%bcond_without tests

%if 0%{?rhel} >= 7 || 0%{?fedora} >= 22
%bcond_without python3
%else
%bcond_with python3
%endif

%if 0%{?rhel} >= 9 || 0%{?fedora} >= 30
%bcond_with python2
%else
%bcond_without python2
%endif

%if %{with python2}
%if %{undefined py2_build}
%global py2_build CFLAGS="%{optflags}" %{__python} setup.py build '--executable=%{__python} -s'
%endif
%if %{undefined py2_install}
%global py2_install CFLAGS="%{optflags}"  %{__python} setup.py install -O1 --skip-build --root %{buildroot}
%endif
%if %{undefined python2_platform}
%global python2_platform %(%{__python2} -Esc "import sysconfig; print(sysconfig.get_platform())")
%endif
%endif

%if %{with python3}
%if %{undefined py3_build}
%global py3_build CFLAGS="%{optflags}" %{__python3} setup.py build '--executable=%{__python3} -s'
%endif
%if %{undefined py3_install}
%global py3_install CFLAGS="%{optflags}"  %{__python3} setup.py install -O1 --skip-build --root %{buildroot}
%endif
%endif

%define unmangled_name dash_hash
%define unmangled_version 1.3.2

Summary: Binding for Dash X11 proof of work hashing
Name: python-%{unmangled_name}
Version: %{unmangled_version}
Release: 3%{?dist}.29
Source0: https://github.com/dashpay/%{unmangled_name}/archive/%{unmangled_version}/%{unmangled_name}-%{unmangled_version}.tar.gz
License: MIT
Group: Development/Libraries
Url: https://github.com/dashpay/dash_hash
Prefix: %{_prefix}
%if %{with python2}
BuildRequires: python2-devel
BuildRequires: python-setuptools
%endif
%if %{with python3}
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-setuptools
%endif

%description
Python module for Dash's X11 hashing.

%if %{with python2}
%package -n python2-%{unmangled_name}
Summary: Binding for Dash X11 proof of work hashing.
Group: Development/Libraries
%{?python_provide:%python_provide python2-%{unmangled_name}}

%description -n python2-%{unmangled_name}
Python module for Dash's X11 hashing.

This package contains the python2 version of this module.

%endif

%if %{with python3}
%package -n python%{python3_pkgversion}-%{unmangled_name}
Summary: Binding for Dash X11 proof of work hashing.
Group: Development/Libraries
%{?python_provide:%python_provide python%{python3_pkgversion}-%{unmangled_name}}

%description -n python%{python3_pkgversion}-%{unmangled_name}
Python module for Dash's X11 hashing.

This package contains the python3 version of this module.

%endif

%prep
%setup -n %{unmangled_name}-%{unmangled_version}

%build
%if %{with python2}
%py2_build
%endif
%if %{with python3}
%py3_build
%endif

%install
%if %{with python3}
%py3_install
%endif
%if %{with python2}
%py2_install
%endif

%check
%if %{with tests}
%if %{with python2}
PYTHONPATH='%{buildroot}%{python2_sitearch}' \
    %{__python2} test.py
%endif
%if %{with python3}
PYTHONPATH='%{buildroot}%{python3_sitearch}' \
    %{__python3} test.py
%endif
%endif

%if %{with python2}
%files -n python2-%{unmangled_name}
%defattr(-,root,root)
%license LICENSE
%doc README.md
%{python2_sitearch}/%{unmangled_name}*.so
%{python2_sitearch}/%{unmangled_name}-%{version}-py*.*.egg-info
%endif

%if %{with python3}
%files -n python%{python3_pkgversion}-%{unmangled_name}
%defattr(-,root,root)
%license LICENSE
%doc README.md
%{python3_sitearch}/%{unmangled_name}*.so
%{python3_sitearch}/%{unmangled_name}-%{version}-py*.*.egg-info
%endif
%changelog
* Fri Oct  7 2022 Oleg Girko <ol@infoserver.lv> - 1.3.2-3
- Use installation directory as PYTHONPATH for tests
* Fri Aug 26 2022 Oleg Girko <ol@infoserver.lv> - 1.3.2-2
- Don't build for Python2 on RHEL >= 9
* Tue Oct 26 2021 Oleg Girko <ol@infoserver.lv> - 1.3.2-1
- Update to 1.3.2
* Mon Oct 25 2021 Oleg Girko <ol@infoserver.lv> - 1.3.1-7
- Fix build on CentOS 7
* Sun Oct 24 2021 Oleg Girko <ol@infoserver.lv> - 1.3.1-6
- Add patch to support Python 3.10
- Add tests and make them conditional
- Make Python2 build conditional and don't build for Python2 on Fedora >= 30
* Sat Oct 23 2021 Oleg Girko <ol@infoserver.lv> - 1.3.1-5
- Fix pattern for egg-info files to allow two-digit Python minor version
* Thu Apr  4 2019 Oleg Girko <ol@infoserver.lv> - 1.3.1-4
- Use proper macro for Python 3 version instead of hardcoding it
* Tue Oct 16 2018 Oleg Girko <ol@infoserver.lv> - 1.3.1-3
- Enable Python3 build for CentOS 7
* Mon Apr 17 2017 Oleg Girko <ol@infoserver.lv> - 1.3.1-2
- Define Python build macros if not defined
* Tue Mar 28 2017 Oleg Girko <ol@infoserver.lv> - 1.3.1-1
- Initial package
